#include "oled.h"
#include "stdlib.h"
#include "oledfont.h"  	 
#include "delay.h"


void OLED_WR_Byte(u8 dat,u8 cmd)
{
	u8 i;
	if(cmd)
	  OLED_DC_Set();
	else 
	  OLED_DC_Clr();
	OLED_CS1_Clr();
	OLED_CS2_Clr();
	for(i=0;i<8;i++)
	{
		OLED_SCLK_Clr();
		if(dat&0x80)
		   OLED_SDIN_Set();
		else 
		   OLED_SDIN_Clr();
		OLED_SCLK_Set();
		dat<<=1;   
	}				 		  
	OLED_CS1_Set();
	OLED_CS2_Set();
	OLED_DC_Set();   	  
}

void OLED_WR_Byte1(u8 dat,u8 cmd,u8 mode)
{
	u8 i;
	if(cmd)
	  OLED_DC_Set();
	else 
	  OLED_DC_Clr();
	if(mode==1)OLED_CS1_Clr();
	if(mode==2)OLED_CS2_Clr();
	for(i=0;i<8;i++)
	{
		OLED_SCLK_Clr();
		if(dat&0x80)
		   OLED_SDIN_Set();
		else 
		   OLED_SDIN_Clr();
		OLED_SCLK_Set();
		dat<<=1;   
	}
	if(mode==1)OLED_CS1_Set();
	if(mode==2)OLED_CS2_Set();
	OLED_DC_Set();
}


//******************************************************************************
//    ˵OLEDʾеʼַֹ
//    ݣx1,x2  еʼַͽַ
//              y1,y2  еʼַͽַ
//    ֵ  
//******************************************************************************
void OLED_Address_Set1(u16 x1,u16 x2,u16 y1,u16 y2,u8 t)
{
	if(x2<80)
	{
		OLED_WR_Byte1(0x21,OLED_CMD,t);
		OLED_WR_Byte1(x1,OLED_CMD,t);
		OLED_WR_Byte1(x2,OLED_CMD,t);
		OLED_WR_Byte1(0x22,OLED_CMD,t);
		OLED_WR_Byte1(y1,OLED_CMD,t);
		OLED_WR_Byte1(y2,OLED_CMD,t);
	}
	else
	{
		OLED_WR_Byte1(0x21,OLED_CMD,1);
		OLED_WR_Byte1(x1,OLED_CMD,1);
		OLED_WR_Byte1(79,OLED_CMD,1);
		OLED_WR_Byte1(0x22,OLED_CMD,1);
		OLED_WR_Byte1(y1,OLED_CMD,1);
		OLED_WR_Byte1(y2,OLED_CMD,1);
		
		OLED_WR_Byte1(0x21,OLED_CMD,2);
		OLED_WR_Byte1(0,OLED_CMD,2);
		OLED_WR_Byte1(x2-80,OLED_CMD,2);
		OLED_WR_Byte1(0x22,OLED_CMD,2);
		OLED_WR_Byte1(y1,OLED_CMD,2);
		OLED_WR_Byte1(y2,OLED_CMD,2);
	}
}

//
void OLED_Clear(u16 x1,u16 y1,u16 x2,u16 y2,u8 color)
{
	u8 j,t=0,sizex;
	u16 i,xt=0;
	x1/=2;
	x2/=2;
	sizex=x2-x1;
	t=1;
	if(x1>80)
  {
		t=2;
		x1-=80;
		x2-=80;
	}
	OLED_Address_Set1(x1,x2-1,y1,y2-1,t);
	for(i=x1;i<x2;i++)
	{
		for(j=y1;j<y2;j++)
		{
			OLED_WR_Byte1(color,OLED_DATA,t);
			if((x1+sizex-1)>79)
			{
				xt++;
				if(xt==sizex) xt=0;
				if(xt+x1>79) t=2;
				else t=1;
			}
	  }
	}
}

//******************************************************************************
//    ˵OLEDʾַ 
//    ˺÷Χַ2ı  ַ߶ǿȵ2
//    ݣx,y   ʼ
//              chr   Ҫдַ
//              sizey ַ߶ 
//    ֵ  
//******************************************************************************
void OLED_ShowChar(u16 x,u16 y,u8 chr,u8 sizey)
{
	u8 j,t=0,c,xt=0;
	u8 i,temp,DATA1=0;
	u16 num;
	c=chr-' ';
	x/=2;
	if(x<80)t=1;
	else 
  {
		t=2;
		x-=80;
	}
	OLED_Address_Set1(x,x+sizey/4-1,y,y+sizey-1,t);
	num=sizey/2*sizey/8;
	for(i=0;i<num;i++)
	{
		if(sizey==16)temp=F8X16[c][i];//8x16ַ
		else if(sizey==32)temp=F16X32[c][i];//16x32ַ
		else if(sizey==48)temp=F24X48[c][i];//24x48ַ
		else return;
		for(j=0;j<4;j++)
		{
			if(temp&0x01)
			{
				DATA1=0xf0;
			}
			temp>>=1;
			if(temp&0x01)
			{
				DATA1|=0x0f;
			}
			temp>>=1;
			OLED_WR_Byte1(DATA1,OLED_DATA,t);
			DATA1=0;
			if(x+sizey/4-1>79)
			{
				xt++;
				if(xt==sizey/4) xt=0;
				if(xt+x>79) t=2;
				else t=1;
			}
		}
	}
}

//******************************************************************************
//    ˵OLEDʾַ
//    ݣx,y  ʼ
//              *dp  Ҫдַ
//              sizey ַ߶ 
//    ֵ  
//******************************************************************************
void OLED_ShowString(u16 x,u16 y,u8 *dp,u8 sizey)
{
	while(*dp!='\0')
	{
	  OLED_ShowChar(x,y,*dp,sizey);
		dp++;
		x+=sizey/2;
	}
}

//******************************************************************************
//    ˵m^n
//    ݣm: n:ָ
//    ֵ  result
//******************************************************************************
u32 oled_pow(u8 m,u8 n)
{
	u32 result=1;
	while(n--)result*=m;    
	return result;
}


//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :	 
//              len :ֵλ
//              sizey:С
//    ֵ  
//******************************************************************************
void OLED_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 sizey)
{         	
	u8 t,temp;
	u8 enshow=0;
	for(t=0;t<len;t++)
	{
		temp=(num/oled_pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				OLED_ShowChar(x+(sizey/2)*t,y,' ',sizey);
				continue;
			}else enshow=1; 
		 	 
		}
	 	OLED_ShowChar(x+(sizey/2)*t,y,temp+'0',sizey); 
	}
}

//******************************************************************************
//    ˵OLEDʾ
//    ݣx,y :	 
//              number :ֵ
//              sizey:С
//    ֵ  
//******************************************************************************
void OLED_ShowChinese(u16 x,u16 y,u8 number,u8 sizey)
{
	u8 j,t=0,xt=0;
	u8 temp,DATA1=0;
	u16 i,num;
	x/=2;
	if(x<80)t=1;
	else 
  {
		t=2;
		x-=80;
	}
	OLED_Address_Set1(x,x+sizey/2-1,y,y+sizey-1,t);
	num=sizey*sizey/8;
	for(i=0;i<num;i++)
	{
		if(sizey==16)temp=Hz16x16[number][i];//16x16ַ
		else if(sizey==24)temp=F24X24[number][i];//24x24ַ
		else if(sizey==32)temp=F32X32[number][i];//32x32ַ
		else return;
		for(j=0;j<4;j++)
		{
			if(temp&0x01)
			{
				DATA1=0xf0;
			}
			temp>>=1;
			if(temp&0x01)
			{
				DATA1|=0x0f;
			}
			temp>>=1;
			OLED_WR_Byte1(DATA1,OLED_DATA,t);
			DATA1=0;
			if(x+sizey/2-1>79)
			{
				xt++;
				if(xt==sizey/2) xt=0;
				if(xt+x>79) t=2;
				else t=1;
			}
		}
	}
}

//******************************************************************************
//    ˵OLEDʾͼƬ
//    ݣx,y :
//              sizex,sizey:ͼƬ
//    ֵ  
//******************************************************************************
void OLED_ShowPicture(u16 x,u16 y,u16 sizex,u16 sizey,const u8 bmp[])
{
	u8 t=0;
	u8 DATA1=0;
	u16 i,num,xt=0;
	x/=2;
	if(x<80)t=1;
	else
  {
		t=2;
		x-=80;
	}
	OLED_Address_Set1(x,x+sizex/2-1,y,y+sizey-1,t);
	num=sizex*sizey/2;
	for(i=0;i<num;i++)
	{
		DATA1=bmp[i];
		OLED_WR_Byte1(DATA1,OLED_DATA,t);
		DATA1=0;
		if((x+sizex/2-1)>79)
		{
			xt++;
			if(xt==sizex/2) xt=0;
			if(xt+x>79) t=2;
			else t=1;
		}
	}
}


//OLEDĳʼ
void OLED_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_AFIO, ENABLE);	 //ʹA˿ʱ
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_15;	 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOA, &GPIO_InitStructure);	  //ʼGPIOA
 	GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_15);	

	OLED_RST_Clr();//λ
	delay_ms(200);
	OLED_RST_Set();
	
	OLED_WR_Byte(0xae,OLED_CMD);//Display OFF 
	OLED_WR_Byte(0xfd,OLED_CMD);//Set Command Lock 
	OLED_WR_Byte(0x12,OLED_CMD); 
	OLED_WR_Byte(0x20,OLED_CMD);//Set Memory Addressing Mode 
	OLED_WR_Byte(0x00,OLED_CMD); 
	OLED_WR_Byte(0x25,OLED_CMD);//Set Portrait Addressing Mode 
	OLED_WR_Byte(0x00,OLED_CMD);//Normal Addressing Mode 
	OLED_WR_Byte(0x81,OLED_CMD);//Set Contrast Control 
	OLED_WR_Byte(0x6b,OLED_CMD); 
	OLED_WR_Byte1(0xa0,OLED_CMD,1);//Set Seg Remap
	OLED_WR_Byte1(0xa1,OLED_CMD,2);
	OLED_WR_Byte(0xa2,OLED_CMD);//Set Display Start Line 
	OLED_WR_Byte(0x00,OLED_CMD); 
	OLED_WR_Byte(0xa4,OLED_CMD);//Resume to RAM content display 
	OLED_WR_Byte(0xa6,OLED_CMD);//Set Normal Display 
	OLED_WR_Byte(0xa8,OLED_CMD);//Set MUX Ratio 
	OLED_WR_Byte(0x83,OLED_CMD);//1/132 duty 
	OLED_WR_Byte(0xad,OLED_CMD);//Select external or internal IREF 
	OLED_WR_Byte(0x10,OLED_CMD); 
	OLED_WR_Byte(0xbc,OLED_CMD);//Set Pre-charge voltage 
	OLED_WR_Byte(0x1e,OLED_CMD);// 
	OLED_WR_Byte(0xbf,OLED_CMD);//Linear LUT 
	OLED_WR_Byte1(0xc8,OLED_CMD,1);//Set COM Output Scan Direction 
	OLED_WR_Byte1(0xc0,OLED_CMD,2);
	OLED_WR_Byte(0xd3,OLED_CMD);//Set Display Offset 
	OLED_WR_Byte1(0x0e,OLED_CMD,1); 
	OLED_WR_Byte1(0x92,OLED_CMD,2); 
	OLED_WR_Byte(0xd5,OLED_CMD);//Set Display Clock Divide Ratio/Oscillator Frequency 
	OLED_WR_Byte(0xc2,OLED_CMD);//85Hz 
	OLED_WR_Byte(0xd9,OLED_CMD);//Set Pre-charge Period 
	OLED_WR_Byte(0x72,OLED_CMD);// 
	OLED_WR_Byte(0xda,OLED_CMD);//Set SEG Pins Hardware Configuration 
	OLED_WR_Byte(0x32,OLED_CMD);
	OLED_WR_Byte(0xbd,OLED_CMD);//Set VP 
	OLED_WR_Byte(0x03,OLED_CMD); 
	OLED_WR_Byte(0xdb,OLED_CMD);//Set VCOMH 
	OLED_WR_Byte(0x30,OLED_CMD);
	OLED_Clear(0,0,320,132,0x00);
	OLED_WR_Byte(0xaf,OLED_CMD);//Display on
}

