

//----------------------------------------------------------------------
//EASTRISING TECHNOLOGY CO,.LTD.//
// Module    : ER-OLEDM0383-1C 
// Lanuage   : C Code
// Create    : JAVEN
// Date      : 2025-03-20
// Drive IC  : SSD1320*2
// INTERFACE : 4 LINE SPI
// MCU 		   : STM32F103C8T6
//----------------------------------------------------------------------

//Hardware connection
// GND    VSS
// VCC    3.3v
// SCK    PA0
// SDA    PA1
// RES    PA2
// DC     PA3
// CS1    PA4 
// CS2    PA5
// FR1    PA6
// FR2    PA7



#include "delay.h"
#include "sys.h"
#include "oled.h"
#include "bmp.h"

int main(void)
{
	u8 t=0;
	delay_init();
	OLED_Init();
	while(1)
	{
		OLED_ShowPicture(0,0,320,132,BMP1);
		delay_ms(1000);
		OLED_Clear(0,0,320,132,0x00);
		OLED_ShowChinese(80,0,0,16);
		OLED_ShowChinese(100,0,1,16);
		OLED_ShowChinese(120,0,2,16);
		OLED_ShowChinese(140,0,3,16);		
		OLED_ShowChinese(160,0,4,16);
		OLED_ShowChinese(180,0,5,16);	
		OLED_ShowChinese(200,0,7,16);
		OLED_ShowChinese(220,0,8,16);			
		
		OLED_ShowString(48,40,"3.83 OLED TEST",32);
		OLED_ShowString(40,80,"EASTRISINB",32);
		OLED_ShowString(40,80,"BUYDISPLAY.COM",32);
		OLED_ShowNum(96,80,320,3,32);
		OLED_ShowNum(256,80,132,3,32);
		delay_ms(1000);
		OLED_Clear(0,0,320,132,0x00);
	}
}

